Implements an XSLT processing filter while copying files.

This is a shortcut for calling the <copy> task with the XSLTFilter used in the <filterchains> section.

author | Andreas Aderhold, andi@binarycloud.com
version | $Id: 8f87e1c7908c06223382baf628d018c3a0f10824 $
package | phing.tasks.system
copyright | 2001,2002 THYRELL. All rights reserved

### Methods

## Sets up this object internal stuff.

    __construct() : object

Inherited

i.e. the Fileutils instance and default mode

access | public
inherited_from | \CopyTask::__construct()

### Returns

`object`The CopyTask instnace

## Nested creator, creates a FileSet for this task

    addFileSet(\FileSet $fs) : void

Inherited

inherited_from | \CopyTask::addFileSet()

### Parameters

#### $fs

## Nested creator, adds a set of files (nested fileset attribute).

    createFileList() : object

Inherited

access | public
inherited_from | \CopyTask::createFileList()

### Returns

`object`The created filelist object

## Creates a filterchain

    createFilterChain() : object

Inherited

access | public
inherited_from | \CopyTask::createFilterChain()

### Returns

`object`The created filterchain object

## Nested creator, creates one Mapper for this task

    createMapper() : object

Inherited

access | public
inherited_from | \CopyTask::createMapper()

### Exceptions

`\BuildException` |

### Returns

`object`The created Mapper type object

## Support nested <param> tags useing XSLTParam class.

    createParam() : \XSLTParam

### Returns

`\XSLTParam`

## Returns the textual description of the task

    getDescription() : string

Inherited

inherited_from | \Task::getDescription()
inherited_from | \CopyTask::getDescription()

### Returns

`string`The text description of the task

## Returns the location within the buildfile this task occurs.

    getLocation() : \Location

Inherited

Used by BuildException to give detailed error messages.

inherited_from | \Task::getLocation()
inherited_from | \CopyTask::getLocation()

### Returns

`\Location`The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

Inherited

inherited_from | \Task::getOwningTarget()
inherited_from | \CopyTask::getOwningTarget()

### Returns

`\Target`The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \Task::getProject()
inherited_from | \CopyTask::getProject()

### Returns

`\Project`Reference to current porject object

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

Inherited

inherited_from | \Task::getRuntimeConfigurableWrapper()
inherited_from | \CopyTask::getRuntimeConfigurableWrapper()

### Returns

`\RuntimeConfigurable`The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

Inherited

inherited_from | \Task::getTaskName()
inherited_from | \CopyTask::getTaskName()

### Returns

`string`Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

Inherited

inherited_from | \Task::getTaskType()
inherited_from | \CopyTask::getTaskType()

### Returns

`string`The type of this task (XML Tag)

## Setup the filterchains w/ XSLTFilter that we will use while copying the files.

    init()

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

### Exceptions

`\BuildException` |

## Provides a project level log event to the task.

    log(string $msg, integer $level)

Inherited

see | \global\BuildEvent
see | \global\BuildListener
inherited_from | \Task::log()
inherited_from | \CopyTask::log()

### Parameters

#### $msg

`string`

The message to log

#### $level

`integer`

The priority of the message

## Set any XSLT Param and invoke CopyTask::main()

    main() : true

This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running phing target1 target2 will run all tasks in target3 twice.

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

see | \global\CopyTask::main()

### Exceptions

`\BuildException` |

### Returns

`true`on success

## Configure this task if it hasn't been done already.

    maybeConfigure()

Inherited

inherited_from | \Task::maybeConfigure()
inherited_from | \CopyTask::maybeConfigure()

## Perfrom this task

    perform()

Inherited

inherited_from | \Task::perform()
inherited_from | \CopyTask::perform()

## Sets a textual description of the task

    setDescription(string $desc)

Inherited

inherited_from | \Task::setDescription()
inherited_from | \CopyTask::setDescription()

### Parameters

#### $desc

`string`

The text describing the task

## Set the file.

    setFile(\PhingFile $file) : void

Inherited

We have to manually take care of the type that is coming due to limited type support in php in and convert it manually if neccessary.

access | public
inherited_from | \CopyTask::setFile()

### Parameters

#### $file

`\string/object`

The source file. Either a string or an PhingFile object

## Set the haltonerror attribute - when true, will make the build fail when errors are detected.

    setHaltonerror(boolean $haltonerror) : void

Inherited

access | public
inherited_from | \CopyTask::setHaltonerror()

### Parameters

#### $haltonerror

`boolean`

Flag if the build should be stopped on errors

## Set the include empty dirs flag.

    setIncludeEmptyDirs(boolean $bool) : void

Inherited

IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

access | public
inherited_from | \CopyTask::setIncludeEmptyDirs()

### Parameters

#### $bool

`boolean`

Flag if empty dirs should be cpoied too

## Sets the location within the buildfile this task occurs.

    setLocation(\Location $location)

Inherited

Called by the parser to set location information.

inherited_from | \Task::setLocation()
inherited_from | \CopyTask::setLocation()

### Parameters

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the mode to create destination directories with (ignored on Windows).

    setMode(integer $mode) : void

Inherited

Default mode is taken from umask()

access | public
inherited_from | \CopyTask::setMode()

### Parameters

#### $mode

`integer`

Octal mode

## Set the overwrite flag.

    setOverwrite(boolean $bool) : void

Inherited

IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

access | public
inherited_from | \CopyTask::setOverwrite()

### Parameters

#### $bool

`boolean`

Overwrite the destination file(s) if it/they already exist

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

Inherited

inherited_from | \Task::setOwningTarget()
inherited_from | \CopyTask::setOwningTarget()

### Parameters

#### $target

`\Target`

Reference to owning target

## Set the preserve timestamp flag.

    setPreserveLastModified(boolean $bool) : void

Inherited

IntrospectionHelper takes care of booleans in set* methods so we can assume that the right value (boolean primitive) is coming in here.

access | public
inherited_from | \CopyTask::setPreserveLastModified()

### Parameters

#### $bool

`boolean`

Preserve the timestamp on the destination file

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \Task::setProject()
inherited_from | \CopyTask::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Whether to resolve entities in the XML document.

    setResolveDocumentExternals(bool $resolveExternals)

since | 2.4

### Parameters

#### $resolveExternals

`bool`

## Whether to resolve entities in the stylesheet.

    setResolveStylesheetExternals(bool $resolveExternals)

since | 2.4

### Parameters

#### $resolveExternals

`bool`

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

Inherited

inherited_from | \Task::setRuntimeConfigurableWrapper()
inherited_from | \CopyTask::setRuntimeConfigurableWrapper()

### Parameters

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Set the stylesheet to use.

    setStyle(\PhingFile $style)

### Parameters

#### $style

`\PhingFile`

## Sets the name of this task for log messages

    setTaskName(string $name) : string

Inherited

inherited_from | \Task::setTaskName()
inherited_from | \CopyTask::setTaskName()

### Parameters

#### $name

`string`

### Returns

`string`A string representing the name of this task for log

## Sets the type of the task.

    setTaskType(string $name)

Inherited

Usually this is the name of the XML tag

inherited_from | \Task::setTaskType()
inherited_from | \CopyTask::setTaskType()

### Parameters

#### $name

`string`

The type of this task (XML Tag)

## Set the toDir.

    setTodir(\PhingFile $dir) : void

Inherited

We have to manually take care of the type that is coming due to limited type support in php in and convert it manually if neccessary.

access | public
inherited_from | \CopyTask::setTodir()

### Parameters

#### $dir

`\string/object`

The directory, either a string or an PhingFile object

## Set the toFile.

    setTofile(\PhingFile $file) : void

Inherited

We have to manually take care of the type that is coming due to limited type support in php in and convert it manually if neccessary.

access | public
inherited_from | \CopyTask::setTofile()

### Parameters

#### $file

`\string/object`

The dest file. Either a string or an PhingFile object

## setTstamp()

    setTstamp($bool)

Inherited

see | \global\CopyTask::setPreserveLastModified
inherited_from | \CopyTask::setTstamp()

### Parameters

#### $bool

## Used to force listing of all names of copied files.

    setVerbose(boolean $verbosity)

Inherited

inherited_from | \CopyTask::setVerbose()

### Parameters

#### $verbosity

`boolean`

## Actually copies the files

    doWork() : void

Inherited

access | private
inherited_from | \CopyTask::doWork()

### Exceptions

`\BuildException` |

## Returns a name

    getRegisterSlot(string $slotName)

Inherited

inherited_from | \Task::getRegisterSlot()
inherited_from | \CopyTask::getRegisterSlot()

### Parameters

#### $slotName

`string`

## logError()

    logError($message, $location)

Inherited

inherited_from | \CopyTask::logError()

### Parameters

#### $message

#### $location

## Validates attributes coming in from XML

    validateAttributes() : void

Inherited

access | private
inherited_from | \CopyTask::validateAttributes()

### Exceptions

`\BuildException` |

## Compares source files to destination files to see if they should be copied.

    _scan($fromDir, $toDir, $files, $dirs) : void

Inherited

access | private
inherited_from | \CopyTask::_scan()

### Parameters

#### $fromDir

#### $toDir

#### $files

#### $dirs

## Builds a map of filenames (from->to) that should be copied

    buildMap($fromDir, $toDir, $names, $mapper, $map) : void

Inherited

access | private
inherited_from | \CopyTask::buildMap()

### Parameters

#### $fromDir

#### $toDir

#### $names

#### $mapper

#### $map

### Properties

##

    $completeDirMap

Inherited

inherited_from | \CopyTask::$$completeDirMap

##

    $description : string

Inherited

inherited_from | \Task::$$description
inherited_from | \CopyTask::$$description

##

    $destDir

Inherited

inherited_from | \CopyTask::$$destDir

##

    $destFile

Inherited

inherited_from | \CopyTask::$$destFile

##

    $dirCopyMap

Inherited

inherited_from | \CopyTask::$$dirCopyMap

##

    $file

Inherited

inherited_from | \CopyTask::$$file

##

    $fileCopyMap

Inherited

inherited_from | \CopyTask::$$fileCopyMap

##

    $fileUtils

Inherited

inherited_from | \CopyTask::$$fileUtils

##

    $filelists

Inherited

inherited_from | \CopyTask::$$filelists

##

    $filesets

Inherited

inherited_from | \CopyTask::$$filesets

##

    $filterChains

Inherited

inherited_from | \CopyTask::$$filterChains

##

    $flatten

Inherited

inherited_from | \CopyTask::$$flatten

##

    $haltonerror

Inherited

inherited_from | \CopyTask::$$haltonerror

##

    $includeEmpty

Inherited

inherited_from | \CopyTask::$$includeEmpty

##

    $location : \Location

Inherited

inherited_from | \Task::$$location
inherited_from | \CopyTask::$$location

##

    $mapperElement

Inherited

inherited_from | \CopyTask::$$mapperElement

##

    $mode

Inherited

inherited_from | \CopyTask::$$mode

##

    $overwrite

Inherited

inherited_from | \CopyTask::$$overwrite

##

    $preserveLMT

Inherited

inherited_from | \CopyTask::$$preserveLMT

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \Task::$$project
inherited_from | \CopyTask::$$project

##

    $target : \Target

Inherited

inherited_from | \Task::$$target
inherited_from | \CopyTask::$$target

##

    $taskName : string

Inherited

inherited_from | \Task::$$taskName
inherited_from | \CopyTask::$$taskName

##

    $taskType : string

Inherited

inherited_from | \Task::$$taskType
inherited_from | \CopyTask::$$taskType

##

    $verbosity

Inherited

inherited_from | \CopyTask::$$verbosity

##

    $wrapper : \RuntimeConfigurable

Inherited

inherited_from | \Task::$$wrapper
inherited_from | \CopyTask::$$wrapper

##

    $parameters

##

    $xsltFilter